<?php
//DeCode By Http://www.360.com.sb

class Linodes
{
	private $apiUrl;
	private $apiKey;

	public function __construct($params)
	{
		$this->apiUrl = $params['configoption1'];
		$this->apiKey = $params['configoption2'];
	}

	public function createCustomFields($pid, $fields)
	{
		if (mysql_num_rows(select_query('tblcustomfields', '*', array('type' => 'product', 'fieldname' => $fields['name'], 'relid' => $pid))) == 0) {
			$values = array('id' => NULL, 'type' => 'product', 'relid' => $pid, 'fieldname' => $fields['name'], 'fieldtype' => $fields['fieldtype'], 'description' => $fields['description'], 'fieldoptions' => $fields['fieldoptions'], 'regexpr' => $fields['regexpr'], 'adminonly' => $fields['adminonly'], 'required' => $fields['required'], 'showorder' => $fields['showorder'], 'showinvoice' => $fields['showinvoice'], 'sortorder' => '0');
			insert_query('tblcustomfields', $values);
		}
		else {
			$values = array('type' => 'product', 'relid' => $pid, 'fieldname' => $fields['name'], 'fieldtype' => $fields['fieldtype'], 'description' => $fields['description'], 'fieldoptions' => $fields['fieldoptions'], 'regexpr' => $fields['regexpr'], 'adminonly' => $fields['adminonly'], 'required' => $fields['required'], 'showorder' => $fields['showorder'], 'showinvoice' => $fields['showinvoice'], 'sortorder' => '0');
			$where = array('type' => 'product', 'fieldname' => $fields['name'], 'relid' => $pid);
			update_query('tblcustomfields', $values, $where);
		}
	}

	public function getList($LinodeID = NULL)
	{
		$data = array('LinodeID' => $LinodeID);
		return $this->doRequest('linode.list', $data);
	}

	public function getJobList($LinodeID = NULL)
	{
		$data = array('LinodeID' => $LinodeID);
		return $this->doRequest('linode.job.list', $data);
	}

	public function getDiskList($LinodeID, $DiskId = NULL)
	{
		$data = array('LinodeID' => $LinodeID, 'DiskID ' => $DiskId);
		return $this->doRequest('linode.disk.list', $data);
	}

	public function getKernels()
	{
		return $this->doRequest('avail.kernels');
	}

	public function getConfigList($LinodeID, $ConfigId = NULL)
	{
		$data = array('LinodeID' => $LinodeID, 'ConfigID ' => $ConfigId);
		return $this->doRequest('linode.config.list', $data);
	}

	public function getIpList($LinodeID = NULL)
	{
		$data = array('LinodeID' => $LinodeID);
		return $this->doRequest('linode.ip.list', $data);
	}

	public function createLinode($datacenterId, $planId, $paymentTerm)
	{
		$data = array('DatacenterID' => $datacenterId, 'PlanID' => $planId, 'PaymentTerm' => $paymentTerm);
		$result = $this->doRequest('linode.create', $data);
		logModuleCall('Linode', 'Create linode', $data, $result);
		return $result;
	}

	public function createSwapDisk($LinodeId, $label, $type, $size)
	{
		$data = array('LinodeID' => $LinodeId, 'Label' => $label, 'Type' => $type, 'Size' => $size);
		$result = $this->doRequest('linode.disk.create', $data);
		logModuleCall('Linode', 'Create Swap Disk', $data, $result);
		return $result;
	}

	public function createDisk($LinodeId, $distributionId, $label, $size, $rootPw)
	{
		$data = array('LinodeID' => $LinodeId, 'DistributionID' => $distributionId, 'Label' => $label, 'Size' => $size, 'rootPass' => $rootPw);
		$result = $this->doRequest('linode.disk.createfromdistribution', $data);
		logModuleCall('Linode', 'Create Disk', $data, $result);
		return $result;
	}

	public function createLinodeConfig($LinodeId, $kernalId, $label, $diskList)
	{
		$data = array('LinodeID' => $LinodeId, 'KernelID' => $kernalId, 'Label' => $label, 'DiskList' => $diskList);
		$result = $this->doRequest('linode.config.create', $data);
		logModuleCall('Linode', 'Create Linode Config', $data, $result);
		return $result;
	}

	public function bootLinode($LinodeId, $ConfigId = NULL)
	{
		$data = array('LinodeID' => $LinodeId, 'ConfigID' => $ConfigId);
		$result = $this->doRequest('linode.boot', $data);
		logModuleCall('Linode', 'Boot linode', $data, $result);
		return $result;
	}

	public function rebootLinode($LinodeId = NULL, $ConfigId = NULL)
	{
		$data = array('LinodeID' => $LinodeId, 'ConfigID' => $ConfigId);
		$result = $this->doRequest('linode.reboot', $data);
		logModuleCall('Linode', 'Reboot linode', $data, $result);
		return $result;
	}

	public function shutdownLinode($LinodeId)
	{
		$data = array('LinodeID' => $LinodeId);
		$result = $this->doRequest('linode.shutdown', $data);
		logModuleCall('Linode', 'Shutdown linode', $data, $result);
		return $result;
	}

	public function deleteDisk($LinodeId, $diskId)
	{
		$data = array('LinodeID' => $LinodeId, 'DiskID' => $diskId);
		$result = $this->doRequest('linode.disk.delete', $data);
		logModuleCall('Linode', 'Delete disk', $data, $result);
		return $result;
	}

	public function deleteConfig($LinodeId, $configId)
	{
		$data = array('LinodeID' => $LinodeId, 'ConfigID' => $configId);
		$result = $this->doRequest('linode.config.delete', $data);
		logModuleCall('Linode', 'Delete config', $data, $result);
		return $result;
	}

	public function deleteLinode($LinodeId, $skipChecks = NULL)
	{
		$data = array('LinodeID' => $LinodeId, 'skipChecks' => $skipChecks);
		$result = $this->doRequest('linode.delete', $data);
		logModuleCall('Linode', 'Delete linode', $data, $result);
		return $result;
	}

	public function resizeLinode($LinodeId, $planId)
	{
		$data = array('LinodeID' => $LinodeId, 'PlanID' => $planId);
		$result = $this->doRequest('linode.resize', $data);
		logModuleCall('Linode', 'Change linode', $data, $result);
		return $result;
	}

	public function updateLinode($postData)
	{
		$data = array('LinodeID' => $postData['linodeid'], 'Alert_cpu_enabled' => $postData['cpu_alert'], 'Alert_diskio_enabled' => $postData['io_alert'], 'Alert_bwin_enabled' => $postData['in_bwi_alert'], 'Alert_bwout_enabled' => $postData['out_bwi_alert'], 'Alert_bwquota_enabled' => $postData['qut_bwi_alert']);

		if (!empty($postData['label'])) {
			$data = array_merge($data, array('Label' => str_replace(' ', '', $postData['label'])));
		}

		if (!empty($postData['cpu_threshold'])) {
			$data = array_merge($data, array('Alert_cpu_threshold' => $postData['cpu_threshold']));
		}

		if (!empty($postData['io_ops'])) {
			$data = array_merge($data, array('Alert_diskio_threshold' => $postData['io_ops']));
		}

		if (!empty($postData['in_bw_threshold'])) {
			$data = array_merge($data, array('Alert_bwin_threshold' => $postData['in_bw_threshold']));
		}

		if (!empty($postData['out_bw_threshold'])) {
			$data = array_merge($data, array('Alert_bwout_threshold' => $postData['out_bw_threshold']));
		}

		if (!empty($postData['bw_qut_threshold'])) {
			$data = array_merge($data, array('Alert_bwquota_threshold' => $postData['bw_qut_threshold']));
		}

		$result = $this->doRequest('linode.update', $data);
		logModuleCall('Linode', 'update linode', $data, $result);
		return $result;
	}

	public function updateDisk($postData)
	{
		$data = array('LinodeID' => $postData['linodeid'], 'DiskID' => $postData['diskid'], 'isReadOnly' => $postData['readonly']);

		if (!empty($postData['label'])) {
			$data = array_merge($data, array('Label' => $postData['label']));
		}

		$result = $this->doRequest('linode.disk.update', $data);
		logModuleCall('Linode', 'update disk', $data, $result);
		return $result;
	}

	public function resizeDisk($postData)
	{
		$data = array('LinodeID' => $postData['linodeid'], 'DiskID' => $postData['diskid'], 'Size' => $postData['size']);
		$result = $this->doRequest('linode.disk.resize', $data);
		logModuleCall('Linode', 'Disk resize', $data, $result);
		return $result;
	}

	public function getAddonSetting($pid = NULL)
	{
		$sql = 'SELECT * FROM `mod_linode` WHERE FIND_IN_SET( \'' . $pid . '\', `product_id` )';
		$query = full_query($sql);
		return array('row' => mysql_num_rows($query), 'result' => mysql_fetch_assoc($query));
	}

	public function saveConfiguration($pid = NULL, $field, $value)
	{
		if (!empty($pid)) {
			$tbl = 'tblproducts';
			$value = array($field => $value);
			$where = array('id' => $pid);
			return update_query($tbl, $value, $where);
		}
	}

	public function getConfiguration()
	{
		$sql = 'SELECT * FROM `tbladdonmodules` WHERE module = \'linode\'';
		$query = full_query($sql);
		$result = array();

		while ($data = mysql_fetch_assoc($query)) {
			$result[] = $data;
		}

		return $result;
	}

	public function updateWhmcsProduct($params, $ID = NULL, $csfId)
	{
		$command = 'updateclientproduct';
		$adminuser = $this->getWhmcsAmin();
		$values['serviceid'] = $params['serviceid'];
		$values['customfields'] = base64_encode(serialize(array($csfId => $ID)));
		$results = localAPI($command, $values, $adminuser);
		return $results;
	}

	public function getWhmcsAmin()
	{
		$result = mysql_fetch_assoc(select_query('tbladmins', 'id', array()));
		return $result['id'];
	}

	public function checkCsfield($name, $pid)
	{
		$result = mysql_fetch_assoc(select_query('tblcustomfields', 'id', array('fieldname' => $name, 'type' => 'product', 'relid' => $pid)));
		return $result['id'];
	}

	public function doRequest($action, $data)
	{
		$query = 'api_key=' . $this->apiKey . '&api_action=' . $action;

		foreach ($data as $key => $value) {
			if (!is_null($value)) {
				$query .= sprintf('&%s=%s', urlencode($key), urlencode($value));
			}
		}

		$curl = curl_init($this->apiUrl);
		curl_setopt($curl, CURLOPT_URL, $this->apiUrl);
		curl_setopt($curl, CURLOPT_POST, true);
		curl_setopt($curl, CURLOPT_POSTFIELDS, $query);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
		$result = curl_exec($curl);
		$json = json_decode($result, true);
		curl_close($curl);
		return $json;
	}
}


?>
